package br.usp.nds.remote.persistencia;

import java.io.Serializable;
import java.util.List;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;

@Entity
public class Colaborador extends Entidade implements Serializable {

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private int codigo;
	private String nome;
	private String registro;
	private byte[] foto;
	private String telefone;
	private String email;
	
	public List<Colaborador> listar() {
		return em.createQuery("SELECT c FROM Colaborador c ORDER BY c.nome").getResultList();
	}

	public void incluir() {
		em.persist(this);
	}
	
	public void alterar() {
		Colaborador c = em.find(Colaborador.class, codigo);
		c.setNome(nome);
		c.setRegistro(registro);
		c.setTelefone(telefone);
		c.setEmail(email);
	}
	
	public void excluir() {
		em.remove(em.find(Colaborador.class, codigo));
	}
	
	public int getCodigo() {
		return codigo;
	}
	public void setCodigo(int codigo) {
		this.codigo = codigo;
	}
	public String getNome() {
		return nome;
	}
	public void setNome(String nome) {
		this.nome = nome;
	}
	public String getRegistro() {
		return registro;
	}
	public void setRegistro(String registro) {
		this.registro = registro;
	}
	public byte[] getFoto() {
		return foto;
	}
	public void setFoto(byte[] foto) {
		this.foto = foto;
	}
	public String getTelefone() {
		return telefone;
	}
	public void setTelefone(String telefone) {
		this.telefone = telefone;
	}
	public String getEmail() {
		return email;
	}
	public void setEmail(String email) {
		this.email = email;
	}
}
