package br.usp.nds.remote.persistencia;

import java.io.Serializable;
import java.math.BigDecimal;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;

@Entity
@NamedQueries({
	@NamedQuery(name = "GeocercaPoligonalCoordenada.remover", query = "DELETE FROM GeocercaPoligonalCoordenada c WHERE c.geocerca.codigo = :geocerca")
})
public class GeocercaPoligonalCoordenada implements Serializable {

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private int codigo;
	private BigDecimal latitude;
	private BigDecimal longitude;
	@ManyToOne
	private GeocercaPoligonal geocerca;
	
	public int getCodigo() {
		return codigo;
	}
	public void setCodigo(int codigo) {
		this.codigo = codigo;
	}
	public BigDecimal getLatitude() {
		return latitude;
	}
	public void setLatitude(BigDecimal latitude) {
		this.latitude = latitude;
	}
	public BigDecimal getLongitude() {
		return longitude;
	}
	public void setLongitude(BigDecimal longitude) {
		this.longitude = longitude;
	}
	public GeocercaPoligonal getGeocerca() {
		return geocerca;
	}
	public void setGeocerca(GeocercaPoligonal geocerca) {
		this.geocerca = geocerca;
	}
}
