package br.usp.nds.remote.persistencia;

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;

@Entity
public class GeocercaPoligonalLimite extends Entidade implements Serializable {

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private int codigo;
	@ManyToOne
	private GeocercaPoligonal geocerca;
	@ManyToOne
	private Embarcacao embarcacao;
	
	public void associar() {
		geocerca = em.getReference(GeocercaPoligonal.class, geocerca.getCodigo());
		embarcacao = em.getReference(Embarcacao.class, embarcacao.getCodigo());
		em.persist(this);
	}
	
	public void desassociar() {
		em.remove(em.find(GeocercaPoligonalLimite.class, codigo));
	}
	
	public int getCodigo() {
		return codigo;
	}
	public void setCodigo(int codigo) {
		this.codigo = codigo;
	}
	public GeocercaPoligonal getGeocerca() {
		return geocerca;
	}
	public void setGeocerca(GeocercaPoligonal geocerca) {
		this.geocerca = geocerca;
	}
	public Embarcacao getEmbarcacao() {
		return embarcacao;
	}
	public void setEmbarcacao(Embarcacao embarcacao) {
		this.embarcacao = embarcacao;
	}
}
