package br.usp.nds.remote.persistencia;

import java.io.Serializable;
import java.util.List;

import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;

import br.usp.nds.remote.integracao.GeradorTickets;

@Entity
public class GeracaoTicket extends Entidade implements Serializable {

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private int codigo;
	private String descricao;
	@ManyToOne
	private GeracaoEvento geracaoEvento;
	@Enumerated(EnumType.STRING)
	private Prioridade prioridade;
	@ManyToOne
	private UsuarioGrupo grupo;
	
	public List<GeracaoTicket> listar() {
		return em.createQuery("SELECT g FROM GeracaoTicket g ORDER BY g.descricao").getResultList();
	}
	
	public void incluir() {
		em.persist(this);
		em.flush();
		em.refresh(this);
		GeradorTickets.getInstance().registrarInsercao(this);
	}
	
	public void alterar() {
		em.merge(this);
		GeradorTickets.getInstance().registrarAlteracao(this);
	}
	
	public void excluir() {
		GeracaoTicket gt = em.find(GeracaoTicket.class, codigo);
		GeradorTickets.getInstance().registrarExclusao(gt);
		em.remove(gt);
	}
	
	public int getCodigo() {
		return codigo;
	}
	public void setCodigo(int codigo) {
		this.codigo = codigo;
	}
	public String getDescricao() {
		return descricao;
	}
	public void setDescricao(String descricao) {
		this.descricao = descricao;
	}
	public GeracaoEvento getGeracaoEvento() {
		return geracaoEvento;
	}
	public void setGeracaoEvento(GeracaoEvento geracaoEvento) {
		this.geracaoEvento = geracaoEvento;
	}
	public Prioridade getPrioridade() {
		return prioridade;
	}
	public void setPrioridade(Prioridade prioridade) {
		this.prioridade = prioridade;
	}
	public UsuarioGrupo getGrupo() {
		return grupo;
	}
	public void setGrupo(UsuarioGrupo grupo) {
		this.grupo = grupo;
	}
}
