package br.usp.nds.remote.persistencia;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Transient;

@Entity
public class TipoSensor extends Entidade {

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private int codigo;
	private String nome;
	@Transient
	private String codigosEmbarcacoes;
	
	public List<Sensor> listar() {
		return em.createQuery("SELECT t FROM TipoSensor t ORDER BY t.nome").getResultList();
	}

	public List listarTiposSensores() {
		List tipos = new LinkedList();
		for (TipoSensor t : (List<TipoSensor>)em.createQuery("SELECT t FROM TipoSensor t ORDER BY t.nome").getResultList()) {
			List sensores = new LinkedList();
			for (Sensor s : (List<Sensor>)em.createQuery("SELECT s FROM Sensor s WHERE " + (codigosEmbarcacoes == null || "".equals(codigosEmbarcacoes) ? "" : "s.embarcacao.codigo IN (" + codigosEmbarcacoes + ") AND ") + "s.tipo.codigo = " + t.getCodigo() + " ORDER BY s.nome").getResultList()) {
				Map sensor = new HashMap();
				sensor.put("nome", s.getNome());
				sensor.put("codigo", s.getCodigo());
				sensores.add(sensor);
			}
			Map tipo = new HashMap();
			tipo.put("nome", t.getNome());
			tipo.put("codigo", t.getCodigo());
			tipo.put("sensores", sensores);
			tipos.add(tipo);
		}
		return tipos;
	}
	
	public void incluir() {
		em.persist(this);
	}
	
	public void alterar() {
		em.merge(this);
	}
	
	public void excluir() {
		em.remove(em.find(TipoSensor.class, codigo));
	}
	
	public int getCodigo() {
		return codigo;
	}
	public void setCodigo(int codigo) {
		this.codigo = codigo;
	}
	public String getNome() {
		return nome;
	}
	public void setNome(String nome) {
		this.nome = nome;
	}
	public String getCodigosEmbarcacoes() {
		return codigosEmbarcacoes;
	}
	public void setCodigosEmbarcacoes(String codigosEmbarcacoes) {
		this.codigosEmbarcacoes = codigosEmbarcacoes;
	}
}
